#ifndef CMA_CODE_DEFINED
#define CMA_CODE_DEFINED

#include <stdlib.h>
#include <vector>

namespace CMa
{
	/**
	 * An implementation of CMa code segment.
	 *
	 * @author OM
	 */
	template<class Word, class Int> class Code
	{
	public:
		vector<Word> data;



		/* Interfaces used by the templates */

		void init()
		{
			// Nothing for now
		}

		void deInit()
		{
			// Nothing for now
		}

		/**
		 * Checks validity of the address.
		 *
		 * @author OM
		 */
		inline bool verifyAddress(Int addr)
		{
			return verifyInterval(addr, addr);
		}

		/**
		 * Checks validity of address interval.
		 *
		 * @author OM
		 */
		inline bool verifyInterval(Int addr1, Int addr2)
		{
			return ((Int)0 <= addr1 && addr2 < (Int)data.size());
		}

		/**
		 * Gives access to the code segment.
		 *
		 * Assumption: verifyAddress(addr) == true
		 *
		 * @author OM
		 */
		inline const Word& operator[](Int addr)
		{
			assert(verifyAddress(addr));
			return data[addr.convertToint()];
		}
	};
}

#endif

